/*
 * Copyright (c) 2019 Adyen N.V.
 *
 * This file is open source and available under the MIT license. See the LICENSE file for more info.
 *
 * Created by caiof on 17/9/2019.
 */

package com.adyen.checkout.wechatpay;

import android.content.Context;
import android.os.Parcel;
import android.os.Parcelable;
import android.support.annotation.NonNull;

import com.adyen.checkout.base.component.BaseConfigurationBuilder;
import com.adyen.checkout.base.component.Configuration;
import com.adyen.checkout.core.api.Environment;

import java.util.Locale;

public class WeChatPayConfiguration extends Configuration {

    public static final Parcelable.Creator<WeChatPayConfiguration> CREATOR = new Parcelable.Creator<WeChatPayConfiguration>() {
        public WeChatPayConfiguration createFromParcel(@NonNull Parcel in) {
            return new WeChatPayConfiguration(in);
        }

        public WeChatPayConfiguration[] newArray(int size) {
            return new WeChatPayConfiguration[size];
        }
    };

    protected WeChatPayConfiguration(@NonNull Locale shopperLocale, @NonNull Environment environment) {
        super(shopperLocale, environment);
    }

    protected WeChatPayConfiguration(@NonNull Parcel in) {
        super(in);
    }

    @Override
    public void writeToParcel(@NonNull Parcel dest, int flags) {
        super.writeToParcel(dest, flags);
    }

    /**
     * Builder to create a {@link WeChatPayConfiguration}.
     */
    public static class Builder extends BaseConfigurationBuilder<WeChatPayConfiguration> {

        /**
         * Constructor for Builder with default values.
         *
         * @param context   A context
         */
        public Builder(@NonNull Context context) {
            super(context);
        }

        /**
         * Builder with required parameters.
         *
         * @param shopperLocale The Locale of the shopper.
         * @param environment   The {@link Environment} to be used for network calls to Adyen.
         */
        public Builder(@NonNull Locale shopperLocale, @NonNull Environment environment) {
            super(shopperLocale, environment);
        }

        @NonNull
        @Override
        public WeChatPayConfiguration build() {
            return new WeChatPayConfiguration(mBuilderShopperLocale, mBuilderEnvironment);
        }
    }
}
